%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Time-Domain-simulation in irregular seas  %
%     Calculating second order kinematics     %
%---------------------------------------------%
%          Compute FFT components             %
%       By: Eivind Bkkedal, 10.06.2014       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [omega, w1, Amp,k,domega]=EAP(m0, w, n_eap,S,g,d,Hs,plott)

%Making EAP components: 
w1=zeros(n_eap+1,1);
omega=zeros(n_eap,1);
domega=zeros(n_eap,1);
% cut=sqrt(g*2/Hs);
cut=sqrt(g*2/Hs);
ixx=find(w>cut,1);
m=m0(ixx)/n_eap;
Amp=sqrt(2*m)*ones(n_eap,1);
% w1(1)=w(1);
w1(1)=2*pi/25;
s=0;
j=0;
for i=2:n_eap+1
    while j<(i-1)*m
        s=s+1;
        j=m0(s);
        if s>=length(m0)-1
           break
        end          
    end
    w1(i)=w(s);
    omega(i-1)=(w1(i)+w1(i-1))/2;
    domega(i-1)=w1(i)-w1(i-1);
end   

% plot EAP if applicable, to ensure process gone ok.
if plott==1
figure()
hold on
xlabel('\omega [rad/s]')
ylabel('S(\omega) [m^2s]')
title(['Discretized wavespecter, ',num2str(n_eao),'-comp EAP method'])
h1=plot(w,S,'k','LineWidth',1.3);
h4=plot(2*pi/4.5*[1 1],[0 100],'--b');
for i=1:n_eap
    A=[w1(i), w1(i), w1(i+1), w1(i+1)];
    S2(i)=Amp(i).^2/(2*(w1(i+1)-w1(i)));
    S1=[0 S2(i) S2(i) 0];
    h3=plot(A,S1,'r');
end
legend([h1 h3 h4],'JONSWAP specter','EAP wave components','\omega_n');
hold off

 for i=1:length(omega);
     k(i,1)=omega(i).^2/g;
     for j=1:20
         k(i,1)=omega(i).^2/(g*tanh(k(i,1)*d));
     end
 end
end
return
