%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Time-Domain-simulation in irregular seas  %
%     Calculating second order kinematics     %
%---------------------------------------------%
%          Compute FFT components             %
%       By: Eivind Bkkedal, 10.06.2014       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [omega, w1, Amp,k,domega]=FFT(nc, w, dw, Tp,S,g,d,Hs)
 cut=sqrt(g*2/Hs);
domega=(cut-w(1))/nc;

%Making FFT components: 
Amp=zeros(nc,1);
Amptemp=zeros(nc,1);
w1=zeros(nc+1,1);
omega=zeros(nc,1);

w1(1)=w(1)+domega/2;
for i=2:nc+1
    w1(i)=w1(1)+domega*(i-1);
    [idx1, idx1] =min(abs(w-w1(i-1))); 
    [idx2, idx2] =min(abs(w-w1(i)));  
    for j=idx1:idx2
        Amptemp(i-1)=Amptemp(i-1)+S(j)*dw;
    end
    Amp(i-1)=sqrt(2*Amptemp(i-1));
    omega(i-1)=(w1(i)+w1(i-1))/2;
end   

 for i=1:length(omega);
     k(i,1)=omega(i).^2/g;
     for j=1:20
         k(i,1)=omega(i).^2/(g*tanh(k(i,1)*d));
     end
 end
return

