%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Time-Domain-simulation in irregular seas  %
%     Calculating second order kinematics     %
%---------------------------------------------%
%           Assemble JONSWAP spectrum         %
%       By: Eivind Bkkedal, 10.06.2014       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [S, w, m0,m1,m2,m3,m4, mm, dw]=JONSWAP(N, Tp, Hs, Gamma)
wp=(2*pi)/Tp;
dw=4/N;
m0(1)=0;
m1=0;
m2=0;
m3=0;
m4=0;
for i=2:N+1
	    w(i-1) = dw*(i-1.5);
  		if(w(i-1)<=wp)
    		sigma = 0.07;
        else
            sigma = 0.09;
        end       
        W= wp/w(i-1);
        S(i-1) = ((5/(32*pi))*Hs^2*Tp)*W^5*exp(-1.25*W^4)*((1 - ...
        0.287*log(Gamma)))*Gamma^(exp(-1/(2*sigma^2)*(1/W-1)^2));
        m0(i)=m0(i-1)+S(i-1)*dw;

        m1=m1+S(i-1)*w(i-1)*dw;
        m2=m2+S(i-1)*w(i-1).^2*dw;
        m3=m3+S(i-1)*w(i-1).^3*dw;
        m4=m4+S(i-1)*w(i-1).^4*dw;
end
mm=2*pi*sum(S.^2)*dw;
return
return