%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Time-Domain-simulation in irregular seas  %
%     Calculating second order kinematics     %
%---------------------------------------------%
%     Writes gridwaves for "Combo" method     %
%       By: Eivind Bkkedal, 10.06.2014       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [UU,AA]=Write_gridwave_NL2(zeta,zeta_2,seed,k,omega,u_minus,seed_minus,k_minus,w_minus,u_plus,seed_plus,k_plus,w_plus,a_minus,a_plus,u_2,u_t,u_l,t,d,ll,ix)

maxx=max(zeta_2);
minn=min(zeta);
z=[-90,-60,-40,-30,-25,minn-5,minn-3,minn-2,(minn-1.5):0.1:maxx+0.2];


fid=fopen(['gwf_Both',num2str(ll),'.w132'],'w+');
fprintf(fid,'''\n');
fprintf(fid,'''\n');
fprintf(fid,' GWF Type 132 \n');
fprintf(fid,'''\n');
fprintf(fid,[' GWF   KeyData  Size   1    1     ',num2str(length(z)),'   ', num2str(length(t)),'    1101 \n']);
fprintf(fid,'''\n');
fprintf(fid,'''\n');
fprintf(fid,' GWF   Grid   X   Constant   -2  2 \n');
fprintf(fid,' GWF   Grid   Y   Constant   -2  2 \n');
fprintf(fid,' GWF   Grid   Z   Free    \n');
for i=1:floor(length(z)/14)
    fprintf(fid,' %.1f  ',z((i-1)*14+1:14+(i-1)*14));
    fprintf(fid,'\n');
end
fprintf(fid,' %.1f  ',z((i)*14+1:end));
fprintf(fid,'\n');
fprintf(fid,'''\n');
fprintf(fid,'''\n');

for i=1:length(t)
    if i>=2000+ix-150 && i<=2000+ix+150
        fprintf(fid,[' GWF    Time    ',num2str(t(i)),'\n']);
        fprintf(fid,'''\n');
        fprintf(fid,' GWF    Elevation\n');
        fprintf(fid,'''\n');
        fprintf(fid,[' ',num2str(zeta_2(i)),'\n']);
        fprintf(fid,'''\n');
        
        fprintf(fid,' GWF    Velocity \n');
        fprintf(fid,'''\n');
        
        for j=1:length(z)
            if z(j)<=zeta_2(i) && z(j)<0
                u(j,1)=sum(u_minus.*cosh(k_minus.*(z(j)+d))./cosh(k_minus.*d).*cos(-w_minus.*t(i)+seed_minus))+...
                    sum(u_plus.*cosh(k_plus.*(z(j)+d))./cosh(k_plus.*d).*cos(-w_plus.*t(i)+seed_plus))+...
                    sum(u_2.*cosh(k.*(z(j)+d))./cosh(k.*d).*cos(-omega.*t(i)+seed));
                
            elseif z(j)<=zeta_2(i) && z(j)>=0
                u(j,1)=sum(u_minus.*cos(-w_minus.*t(i)+seed_minus))+...
                    sum(u_plus.*cos(-w_plus.*t(i)+seed_plus))+...
                    sum(u_2.*cos(-omega.*t(i)+seed))+z(j).*sum(u_t.*sinh(k.*d)./cosh(k.*d).*cos(-omega.*t(i)+seed));
            else
                u(j,1)=0;
            end                
                u(j,2)=0;
                u(j,3)=0;
                fprintf(fid,' %f ',u(j,:));
                fprintf(fid,'\n');
        end
        
        fprintf(fid,'''\n');
        fprintf(fid,' GWF    Acceleration\n');
        fprintf(fid,'''\n');
        
        for j=1:length(z)
            if z(j)<=zeta_2(i) && z(j)<0
                a(j,1)=sum(a_minus.*cosh(k_minus.*(z(j)+d))./cosh(k_minus.*d).*sin(-w_minus.*t(i)+seed_minus))+...
                    sum(a_plus.*cosh(k_plus.*(z(j)+d))./cosh(k_plus.*d).*sin(-w_plus.*t(i)+seed_plus))+...
                    sum(u_2.*omega.*cosh(k.*(z(j)+d))./cosh(k.*d).*sin(-omega.*t(i)+seed));
            elseif z(j)<=zeta_2(i) && z(j)>=0
                a(j,1)=sum(a_minus.*sin(-w_minus.*t(i)+seed_minus))+...
                    sum(a_plus.*sin(-w_plus.*t(i)+seed_plus))+...
                    sum(u_2.*omega.*sin(-omega.*t(i)+seed))+z(j).*sum(u_t.*omega.*sinh(k.*d)./cosh(k.*d).*sin(-omega.*t(i)+seed));
            else
                a(j,1)=0;
                a(j,3)=0;
            end
            a(j,2)=0;
            a(j,3)=0;
            fprintf(fid,' %f ',a(j,:));
            fprintf(fid,'\n');
        end
        
        fprintf(fid,'''\n');
        fprintf(fid,'''\n');
        
    else
        fprintf(fid,[' GWF    Time    ',num2str(t(i)),'\n']);
        fprintf(fid,'''\n');
        fprintf(fid,' GWF    Elevation\n');
        fprintf(fid,'''\n');
        fprintf(fid,[' ',num2str(zeta(i)),'\n']);
        fprintf(fid,'''\n');
        
        z_corr=(z-zeta(i))./(1+zeta(i)/d);
        fprintf(fid,' GWF    Velocity \n');
        fprintf(fid,'''\n');
        for j=1:length(z)
            if z_corr(j)<=0
                u(j,1)=sum(u_l.*cosh(k.*(z_corr(j)+d))./cosh(k.*d).*cos(-omega.*t(i)+seed));
            else
                u(j,1)=0;
            end
            u(j,3)=0;
            u(j,2)=0;
            fprintf(fid,' %f ',u(j,:));
            fprintf(fid,'\n');
        end
        
        fprintf(fid,'''\n');
        fprintf(fid,' GWF    Acceleration\n');
        fprintf(fid,'''\n');
        
        for j=1:length(z)
            if z_corr(j)<=0
                
                a(j,1)=sum(omega.*u_l.*cosh(k.*(z_corr(j)+d))./cosh(k.*d).*sin(-omega.*t(i)+seed));
            else
                a(j,1)=0;
            end
            a(j,3)=0;
            a(j,2)=0;
            fprintf(fid,' %f ',a(j,:));
            fprintf(fid,'\n');
        end
        fprintf(fid,'''\n');
        fprintf(fid,'''\n');
    end
    
    
    if ceil(t(i)/10)*10==t(i)
        disp(['time=',num2str(t(i))]);
    end
    
    if max(u(:,1))==max(abs(u(:,1)))
        UU(i)=max(u(:,1));
    else
        UU(i)=-max(abs(u(:,1)));
    end
    if max(a(:,1))==max(abs(a(:,1)))
        AA(i)=max(a(:,1));
    else
        AA(i)=-max(abs(a(:,1)));
    end
    
end
fprintf(fid,''' \n');
fprintf(fid,' GWF    End \n');
fprintf(fid,''' \n');
fprintf(fid,''' \n');
fprintf(fid,''' -------------- e o f --------------');
fclose('all');


