%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Time-Domain-simulation in irregular seas  %
%     Calculating second order kinematics     %
%---------------------------------------------%
% Assemble wave spectrum and find linear comp %
%       By: Eivind Bkkedal, 10.06.2014       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [zeta_aa,omega,w1,k,domega,S,w, m0,m1,m2,m3,m4, mm, dw]=linear_waves(N, Tp, Hs, Gamma,n, g,d,decomp,spect,plott)

global Tn density
% Setting up the JONSWAP or PM spectrum
if spect==1
    [S, w, m0,m1,m2,m3,m4, mm, dw]=JONSWAP(N, Tp, Hs, Gamma);
else
        [S, w, m0,m1,m2,m3,m4, mm,dw]=PM(N, Tp, Hs, Gamma,g)
end

%Setting up the components from complete spectrum, using the wanted
%method and a Stanbserg cut frequency.
if decomp==1
    [omega, w1, zeta_aa,k,domega]=FFT(n, w, dw, Tp,S,g,d,Hs);
elseif decomp==2
    [omega, w1, zeta_aa,k,domega]=EAP(m0, w, n,S,g,d,Hs,plott);
elseif decomp==3
    [omega, w1, zeta_aa,k,domega]=EAP_p(m0, w, n,dw,S,Tn,density,g,d,Hs,plott);
end
