%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Time-Domain-simulation in irregular seas  %
% Study 3: various methods of simulatinf spect%
%  Simulating surface and writing to files    %
%       By: Eivind Bkkedal, 10.06.2014       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [zeta, zeta_statistical]=surface_realization(zeta_a,w,w1,seed,t,dt,init,j,random,number)

% Deciding whether to use random frequency, amplitude phase or combination
if j==2
    for i=1:length(zeta_a)
        omega(i,1)=w1(i)+random(i,1)*(w1(i+1)-w1(i));
    end
elseif j==1
    for i=1:length(zeta_a)
        omega=w;

        zeta_a(i,1)=raylinv(random(i,2),sqrt(zeta_a(i).^2/2));
    end
elseif j==3
    for i=1:length(zeta_a)
        omega(i,1)=w1(i)+random(i,1)*(w1(i+1)-w1(i));
        zeta_a(i,1)=raylinv(random(i,2),sqrt(zeta_a(i).^2/2));
    end
else
    omega=w;
end


% Create surface history and statistical parameters
zeta=zeros(1,length(t)-init/dt);
for i=1:length(t)-init/dt
    zeta(i)=sum(zeta_a.*cos(-omega.*t(i+init/dt)+seed));
end

zeta_statistical=[max(abs(zeta)) 0 max(zeta) min(zeta)  var(zeta) 0 kurtosis(zeta) skewness(zeta) mean(zeta)];

%Writing wavecomponents to file for USFOS force and response computations
fid=fopen([num2str(number),'.txt'],'w');
fprintf(fid,'''    ------------   W a v e  C o m p o n e n t s  --------------\n');

fprintf(fid,'''\n');
fprintf(fid,'''           Comp     Amplitude   Period   Dir   Phase   \n');
for jj=1:length(zeta_a)
    T_FFT(jj)=2*pi/omega(jj);
    fprintf(fid,'%13d %12.6f %9.5f %3.0f %4.0f \n',jj,zeta_a(jj),...
        T_FFT(jj),0,(seed(jj)-pi/2)*180/pi);
end
fprintf(fid,'''\n');
fprintf(fid,'''\n');
